<?php
class WchainedLogicQuizzes {
   static $last_answer;
   
	static function answer_question() {
		global $wpdb, $question_catids;		
		$_question = new WTPQuestion();
		$question_catids = array();
		if(!is_array(WTPQuestion :: $advanced_settings)) WTPQuestion :: $advanced_settings = array();
		WTPQuestion :: $advanced_settings['dont_display_question_numbers'] = true;
		$log = '';
		
		// select quiz
		$quiz = $wpdb->get_row($wpdb->prepare("SELECT * FROM ".WATUPRO_EXAMS." WHERE ID=%d", intval($_POST['quiz_id'])));
		$_question->exam = $quiz; 
		
		// select question
		$question = $wpdb->get_row($wpdb->prepare("SELECT tQ.*, tC.use_logic as use_logic, tC.logic_samecat as logic_samecat,
			tC.logic_goto as logic_goto, tC.logic_percent as logic_percent, tC.logic_trigger as logic_trigger, tC.logic_mode as logic_mode 
			FROM ".WATUPRO_QUESTIONS." tQ LEFT JOIN ".WCHAINED_CHAINS." tC ON tC.question_id = tQ.ID AND tC.exam_id=%d
			WHERE tQ.ID=%d", intval($_POST['quiz_id']), intval($_POST['question_id'])));

		// prepare $answer var
		$answer = $_POST['answer-'.$_POST['question_id']];
		if(empty($answer[0])) $answer = array(0);
		//print_r($answer);
		
		// check if answer is correct only if the question uses threshold logic
		$percent_correct = 0;		
		list($points, $correct, $is_empty) = WTPQuestion::calc_answer($question, $answer);
		//print_r($answer);
		$log .= "Correct: $correct <br>";
		// prepare session vars if they are not set
		if(empty($_SESSION['wchained_evaluations_'.$quiz->ID])) {
			$_SESSION['wchained_evaluations_'.$quiz->ID] = array();
		}		
		$_SESSION['wchained_evaluations_'.$quiz->ID][$question->ID] = $correct; // mark if this question is correct
				
		if(!empty($question->use_logic) and (empty($question->logic_mode) or $question->logic_mode == 'percent')) {	
			//print_r($_SESSION['wchained_evaluations_'.$quiz->ID]);
			// figure out % correct up to this point
			$num_correct = $percent_correct = 0;
			$log .= 'Question uses logic<br>';
			
			if(empty($question->logic_samecat)) {
				$log .=  'Any category<br>';
				// logic threshold regardless the question category
				foreach($_SESSION['wchained_evaluations_'.$quiz->ID] as $key => $val) $num_correct += $val;
				$num_questions = count($_SESSION['wchained_evaluations_'.$quiz->ID]);
			
				$percent_correct = $num_correct ? round(100 * ($num_correct / $num_questions)) : 0;		
			}
			else {			
				$log .=  'Same category<br>';	
				// logic threshold in the same question category
				$qids = array(0);
				foreach($_SESSION['wchained_evaluations_'.$quiz->ID] as $key => $val) {
					if(!in_array($key, $qids)) $qids[] = $key;
				}
				
				// create array of questions along with their cat IDs
				$qs = $wpdb->get_results("SELECT ID, cat_id FROM ".WATUPRO_QUESTIONS." WHERE ID IN (".implode(',', $qids).")");
				$num_questions = 0;
				foreach($_SESSION['wchained_evaluations_'.$quiz->ID] as $key => $val) {
					foreach($qs as $q) {
						if($q->ID == $key and $q->cat_id == $question->cat_id) {
							$num_correct += $val;
							$num_questions++;
						}
					}
				}
				$percent_correct = $num_correct ? round(100 * ($num_correct / $num_questions)) : 0;
			} // end when logic threshold is in the same cat
			
			$log .= "PERCENT $percent_correct<br>";
		}
							
		// figure out next question
		$next_question = self :: next_question($question, $answer, $percent_correct, $log, $correct);
		
		if(!empty($next_question->ID)) {
			$log .= "Next question found: ".$next_question->ID."<br>";
			$question = $next_question;
			$question->cat = '';
			
			// select answers
			$answers = $wpdb->get_results($wpdb->prepare("SELECT * FROM ".WATUPRO_ANSWERS." WHERE question_id=%d ORDER BY sort_order, ID", $question->ID));
			$question->q_answers = $answers;
			
			echo "next|WCHAINED_LOGIC|";
			echo '<div class="watu-question wchained-question-'.$question->ID.'" id="wchained-question-'.$question->ID.'">';
			ob_start();
		
		   $prev_answer_text = get_option('wchained-logic-prev-text-'.$quiz->ID);
		   if(!empty($prev_answer_text)) {
		      $prev_answer_text = str_replace('{{{prev-answer}}}', stripslashes(self :: $last_answer), $prev_answer_text);
		      $question->question = '<p>' . $prev_answer_text . '</p>' . $question->question;
		   }  
		   			
			$_question->display($question, 1, 1, null, $quiz);
			$question_contents = ob_get_clean();
			// remove question numbers
			$question_contents = str_replace("class='watupro_num'", 'style="display:none;"', $question_contents);
			echo do_shortcode($question_contents);
			echo '</div>|WCHAINED_LOGIC|'.$question->ID;		
			
			// output the serialized ID:answer_ids info for the watupro_questions hidden field
			echo '|WCHAINED_LOGIC|';
			echo $question->ID.':';
			foreach($answers as $cnt=>$answer) {
				if($cnt > 0) echo ',';
				echo $answer->ID;
			}
		}
		else {
			$log .= "Next question not found<br>";
			 // unset session vars used by correct logic
			 unset($_SESSION['wchained_evaluations_'.$quiz->ID]); 			
			
			 // output text to say the question must be submitted
			 echo "submit|WCHAINED_LOGIC|";
		}	 	
		
		session_write_close();	
		
		if(get_option('wchained_enable_log') == 1) {
			$wpdb->query($wpdb->prepare("INSERT INTO ".WCHAINED_LOGS." SET datetime=%s, question_id=%d, log=%s",
				current_time('mysql'), $question->ID, $log));
		}
		
		// store progress?
		if(!empty($_POST['store_progress'])) {
			$_POST['exam_id'] = $quiz->ID;			
			$taking_id = watupro_store_details();		
			
			$chained_evaluations = empty($_SESSION['wchained_evaluations_'.$quiz->ID]) ? '' : serialize($_SESSION['wchained_evaluations_'.$quiz->ID]);
			
			// we need to update serialized questions because WatuPRO normally does it only on the first request
			if(!empty($taking_id)) $wpdb->query($wpdb->prepare("UPDATE ".WATUPRO_TAKEN_EXAMS." SET 
				serialized_questions=%s, chained_evaluations=%s WHERE ID=%d", 
				sanitize_text_field($_POST['watupro_questions']), $chained_evaluations, $taking_id));
				
 		} // end store_progress
	} // end answer_question
	
	// $percent_correct is optional and used only when runtime logic is used
	static function next_question($question, $answer, $percent_correct = 0, &$log = null, $correct = 0) {
 		global $wpdb; 	
 		
		// select answer(s)
		$goto = array();
		$answer_ids = array(0);
		self :: $last_answer = '';
		
		if($question->answer_type == 'textarea') {
		    self :: $last_answer = $answer[0];	
		    
			  $answer = $wpdb->get_var($wpdb->prepare("SELECT id FROM ".WATUPRO_ANSWERS."
	  		  WHERE question_id=%d AND answer LIKE %s", $question->ID, $answer[0]));
	  		  
	  		  if(!empty($answer)) $answer_ids[] = $answer;
		} 
		elseif($question->answer_type == 'gaps') {
		    self :: $last_answer = 'nonempty'; // for gaps just assume it's answered 
		} 
		else {
			// radios and checkboxes
			foreach($answer as $cnt => $ans) {
				 if(!empty($ans)) {
				    $answer_ids[] = $ans;
				    
				    // add to last_answer
				    $text_answer = $wpdb->get_var($wpdb->prepare("SELECT answer FROM ".WATUPRO_ANSWERS." 
				     WHERE question_id=%d AND ID=%d", $question->ID, $ans));
				    if(!empty($text_answer)) {
				       if(!empty(self :: $last_answer)) self :: $last_answer .= ", ";
				       self :: $last_answer .= $text_answer;
				    } 
				 }
			}
		}
		
		// select exam
		$exam = $wpdb->get_row($wpdb->prepare("SELECT ID, reuse_questions_from FROM ".WATUPRO_EXAMS." WHERE ID=%d", $_POST['quiz_id']));
		$q_exam_id = $exam->reuse_questions_from ? $exam->reuse_questions_from : $exam->ID;	
		
		// select the choices selected by the user	
		// question ID is 0 because we don't need question based chains here	
		$choices = $wpdb->get_results($wpdb->prepare("SELECT * FROM ".WCHAINED_CHAINS." 
			WHERE exam_id=%d AND question_id=0 AND choice_id IN (".implode(",", $answer_ids).") ", $exam->ID));	
		/*echo $wpdb->prepare("SELECT * FROM ".WCHAINED_CHAINS." 
			WHERE exam_id=%d AND question_id=0 AND choice_id IN (".implode(",", $answer_ids).") ", $exam->ID);
			
		print_r($choices);	*/		
			
		foreach($choices as $choice) {
			if(isset($goto[$choice->goto])) $goto[$choice->goto]++;
			else $goto[$choice->goto] = 1;			
		}
	   //print_r($goto);
		// now sort goto to figure out what's the top goto selection	
		arsort($goto);		
		$goto = array_flip($goto);
		$key = array_shift($goto);
		
		// let's treat textareas in different way. If answer is not found, let's not finalize the quiz but go to next
		if(($question->answer_type == 'textarea' or $question->answer_type == 'gaps' or $question->answer_type == 'slider') and empty($key)) $key = 'next';
		$log .= "KEY $key<br>";
				
		// if the question uses runtime logic, ignore the above and define the key here
		if(!empty($question->use_logic)) {			
			$log .= "use logic, percent correct: $percent_correct<br>";
			//print_r($question);	
			//print_r($_SESSION['wchained_evaluations_'.$exam->ID]);
			if(!empty($question->logic_mode) and $question->logic_mode == 'question') {
				// the question is correct/wrong behavior (added from version 3.8)
				if($question->logic_trigger == 'correct' and $correct) $key = $question->logic_goto;
				if($question->logic_trigger == 'wrong' and !$correct) $key = $question->logic_goto;
			}
			else {
				// default behavior: percentage based logic
				if(($question->logic_trigger == 'above' and $question->logic_percent < $percent_correct)
					or ($question->logic_trigger == 'below' and $question->logic_percent > $percent_correct)) {
						// use the logic goto. Otherwise just continue
					$log .= "Using logic goto $key<br>";	
					$key = $question->logic_goto;			
					//echo "KEYL $key";	
				}	// end defining key for percent based logic
			}
		} // end use logic
		
	   $log .= "KEY 1: $key<br>";
		
		// if the answer is empty, $key becomes 'next;
		if(empty(self :: $last_answer)) $key = 'next';
		
		$log .= "KEY 2: $key<br>";

		if(empty($key) or $key == 'finalize') return false;
		
		$log .= "KEY 3: $key<br>";

		if($key == 'next') {			
				// select next question by ID
				$question = $wpdb->get_row($wpdb->prepare("SELECT * FROM ".WATUPRO_QUESTIONS." 
				WHERE exam_id=%d AND sort_order>%d  AND answer_type IN ('radio', 'checkbox', 'textarea', 'text', 'gaps', 'sort', 'slider')  
				AND is_inactive=0 AND ID!=%d
				ORDER BY sort_order LIMIT 1", $q_exam_id, $question->sort_order, $question->ID));	
				//print_r($question);
				return $question;		
		}
	
	  if(is_numeric($key)) {
	  	$question = $wpdb->get_row($wpdb->prepare("SELECT * FROM ".WATUPRO_QUESTIONS." 
				WHERE exam_id=%d AND ID=%d AND is_inactive=0 LIMIT 1", $q_exam_id, $key));	
		return $question;			
	  }
	  
	  // just in case
	  return false;		
	} // end next()
}