<?php 
function wchained_shortcode($atts) {
	global $wpdb;
	$quiz_id = $atts['quiz_id'];
	$user_id = get_current_user_id();
	
	$button_text = get_option('wchained_button_text');
	$button_text = empty($button_text) ? __('Go Ahead', 'wchained') : stripslashes($button_text);
	
	wp_enqueue_script(
			'wchained-main',
			WCHAINED_URL."js/main.js",
			array('jquery'),
			'0.7');
			
	// required questions follow WatuPRO selections
	$required_from_watupro = get_option('wchained_required_from_watupro');	
			
	$translation_array = array('please_answer' => __('Please answer the question', 'wchained'),
		'button_text' => $button_text,
		'required_from_watupro' => $required_from_watupro,
		'ajax_url' => admin_url('admin-ajax.php'));
		wp_localize_script( 'wchained-main', 'wchained_i18n', $translation_array );			
	
	// find the first question ID
	$first_question_id = $wpdb->get_var($wpdb->prepare("SELECT ID FROM ".WATUPRO_QUESTIONS."
		WHERE exam_id=%d AND is_inactive=0 ORDER BY sort_order, ID LIMIT 1", $quiz_id));
				
	// make sure there's no crap in session when we load the page	
	if(isset($_SESSION['wchained_evaluations_'.$quiz_id])) unset($_SESSION['wchained_evaluations_'.$quiz_id]); 			
	
	// store progress and in_progress attempt?		
	$store_progress = $wpdb->get_var($wpdb->prepare("SELECT store_progress FROM ".WATUPRO_EXAMS." WHERE ID=%d", $quiz_id));
	if($store_progress) {
		if(is_user_logged_in()) {			
			$in_progress = $wpdb->get_row($wpdb->prepare("SELECT * FROM ".WATUPRO_TAKEN_EXAMS." 
					WHERE user_id=%d AND exam_id=%d AND in_progress=1 ORDER BY ID DESC LIMIT 1", $user_id, $quiz_id));
		}
		else {
			if(!empty($_COOKIE['watupro_taking_id_' . $exam_id])) {
				$in_progress = $wpdb->get_row($wpdb->prepare("SELECT * FROM ".WATUPRO_TAKEN_EXAMS." 
					WHERE ID=%d AND in_progress=1", intval($_COOKIE['watupro_taking_id_' . $exam_id])));		
			}
		}
		
		if(!empty($in_progress->ID)) {
			// select all answered questions to replace $first_question_id with a comma separated list
			$question_ids = $wpdb->get_results($wpdb->prepare("SELECT question_id FROM ".WATUPRO_STUDENT_ANSWERS." WHERE taking_id=%d ORDER BY ID", $in_progress->ID));
			$qids = array();
			foreach($question_ids as $qid) $qids[] = $qid->question_id;
			if(empty($qids)) $qids[] = $first_question_id; // just in case
			$first_question_id = implode(',', $qids);
			
			if(!empty($in_progress->chained_evaluations)) {
				$_SESSION['wchained_evaluations_'.$quiz_id] = unserialize($in_progress->chained_evaluations);
			}
		}
	} // end loading in_progress
	
	session_write_close();	
	$content = do_shortcode('[watupro '.$quiz_id.' question_ids="'.$first_question_id.'"]');		
	
	// remove question numbers
	$content = str_replace("class='watupro_num'", 'style="display:none;"', $content);
	return $content;
}